
/*
** Memory manager version 2.0
** Supports EMS and swap files.
** Test program.
** R. Grehan -- BYTE Magazine
** Use this program as guidance on how to call the
** memory manager (found in memory1.asm)
*/
#include <stdio.h>
#include <dos.h>

/*
** External definitions
*/
extern initmem();
extern closemem();
extern unsigned int gethandle();
extern unsigned int lockhandle();

/*
** Global variables.
*/
unsigned int mnodes;		/* # of mnodes to allocate */
struct memstruct {
	unsigned int convparas;
	unsigned long emsparas;
	int fflag;
} ;
struct memstruct mstruct;	/* Memory manager structure */

unsigned int i;			/* Loop counter */
main()
{
unsigned int myhand1;		/* Handle to memory block */
unsigned int myseg1;		/* Segment address of block */
unsigned int myhand2, myseg2;
unsigned int myhand3, myseg3;
char far *farptr;

	/* Initialize the memory manager */
	mnodes=100;		/* 100 mnodes */
	printf(" Initializing memory manager\n");
	initmem(mnodes,"SWAP.DAT",&mstruct);

	/* Allocate a memory block */
	myhand1=gethandle(100);

	/* Lock the block */
	myseg1=lockhandle(myhand1);

	/* Fill it up with stuff */
	farptr=(char far *)MK_FP(myseg1,0);
	for(i=0;i<100;i++)
		*farptr++='A';

	/* Unlock it */
	unlockhandle(myhand1);

	/* Allocate a new one */
	myhand2=gethandle(400);
	myseg2=lockhandle(myhand2);
	farptr=(char far *)MK_FP(myseg2,0);
	for(i=0;i<6400;i++)
		*farptr++='B';
	unlockhandle(myhand2);

	/* Allocate a really big one (force swapping) */
	myhand3=gethandle(500);
	myseg3=lockhandle(myhand3);
	farptr=(char far *)MK_FP(myseg3,0);
	for(i=0;i<8000;i++)
		*farptr++='C';

	/* Do some interleaved locks and unlocks */
	myseg1=lockhandle(myhand1);
	unlockhandle(myhand1);
	myseg2=lockhandle(myhand2);
	farptr=(char far *)MK_FP(myseg2,0);
	printf("Char is %c\n",*farptr);
	unlockhandle(myhand2);
	myseg3=lockhandle(myhand3);
	farptr=(char far *)MK_FP(myseg3,0);
	printf("Char is %c\n",*farptr);

	/* Close the memory manager */
	closemem();
	exit(0);
}
